



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java反射之基础概念</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java反射之基础概念</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 09:58:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>0.实例准备</p>
<div>
<pre class="prettyprint linenums">package com.blueStarWei.invoke;

public class Student {<br />
    private String name;

    public Student() { }

    public Student(String name) {<br />
        super();<br />
        this.name = name;<br />
    }<br />
    public void setName(String name) {<br />
        this.name = name;<br />
    }<br />
    public String getName() {<br />
        return name;<br />
    }

    @Override<br />
    public String toString() {<br />
        return "Student [name=" + name + "]";<br />
    }<br />
}</pre>
</div>
<p>1. 什么是反射</p>
<p>　　反射是在运行时（非编译时）动态获取类型的信息（比如：接口信息、成员信息、方法信息等），然后根据这些获取的信息创建对象、访问修改成员、调用方法。</p>
<p>2. 获取Class类的方式（3种）：</p>
<div>
<pre class="prettyprint linenums">//方式一：Class.forName("包名.类名")<br />
Class stu1 = Class.forName("com.blueStarWei.invoke.Student");<br />
//方式二：类名.class<br />
Class stu2 = Student.class;<br />
//方式三：实例.getClass()<br />
Class stu3 = new Student().getClass();</pre>
</div>
<p>3. 创建实例对象</p>
<div>
<pre class="prettyprint linenums">Student student = (Student) stu.newInstance();</pre>
</div>
<p>备注：1）该方法通过无参构造的方式创建实例</p>
<p>2）New一个对象的时候，类可以没有被加载；使用newInstance（）方法的时候，必须保证这个类已经加载且已经连接【通过Class.forName()实现】。</p>
<div>
<pre class="prettyprint linenums">Class clazz = Class.forName("com.blueStarWei.invoke.Student");<br />
Student student1 = (Student) clazz.newInstance();<br />
//等价于<br />
Student student2 = new Student();</pre>
</div>
<p>4. 反射的作用</p>
<p>4.1 判断任意一个对象所属的类；</p>
<p>4.2 判断任意一个类所具有的成员变量和方法；</p>
<p>4.3 调用任意对象的方法；</p>
<p>4.4 构造任意一个类的对象；</p>
<p>4.5 生成动态代理操作。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1r3008.html">Rafy 领域实体框架 - 树型实体功能（自关联表）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyymwgq.html">Devexpress  RaisePropertyChanged</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8edjvz9.html">python操作Excel读写--使用xlrd</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd15vdq.html">linux常用命令&colon;5网络命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgr378.html">linux权限管理&lowbar;ACL权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y4nz0q.html">HDU 1098 Ignatius&amp;&num;39&semi;s puzzle&lpar;数学归纳&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0616wq.html">GitHub简历</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v3wrj8.html">Android Init语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg4nz78.html">Compile Time Assertion&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmk4k9.html">zencart低版本由php5&period;2&period;17升级PHP5&period;3环境下错误及解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zgxve9.html">想询问一个职业规划的问题，前端开发 or nodejs&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjyko38.html">&lbrack;AHOI2012&rsqb;树屋阶梯</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kxpe09.html">阿里云部署mongdb（CentOS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16jdoq.html">C&num; Task 篇幅一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj3gng8.html">Vue（一）安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwkg09.html">The History of spring</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1n71lq.html">C&plus;&plus; Coroutine简明教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omzj18.html">WPF popup自动关闭</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omyxj8.html">利用redis List队列简单实现秒杀 PHP代码实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwk4mj9.html">jmeter插件使用说明</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdwok3j9.html">Tomcat解决中文乱码并部署项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjdgnl9.html">用flask实现的添加后保留原url搜索条件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyr6r2q.html">单击列表行前边的checkbox被选中，再单击，取消选中</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wn3kgq.html">《剑指offer》 二进制中1的个数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj5rd59.html">hdu4003</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv54z28.html">node&period;js 框架express有关于router的运用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2pzjrq.html">springboot动态多数据源切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1pgp49.html">String 类的实现（2）引用计数与写时拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4o2wx9.html">deeplearning 重要调参参数分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv5k038.html">lsattr  chattr 文件安全设置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
